#!/bin/bash

echo "Compiling slotsig bench..."
#g++ -O2 -Wall -o slotsig_m2o.x ../slotsig/slotsig_bases.cpp slotsig_m2o.cpp -lstdc++
#g++ -O2 -Wall -o slotsig_o2m.x ../slotsig/slotsig_bases.cpp slotsig_o2m.cpp -lstdc++
#g++ -O2 -Wall -o slotsig_rand.x ../slotsig/slotsig_bases.cpp slotsig_rand.cpp -lstdc++

echo "Compiling qt bench..."
#moc bench_qt.h > moc_bench_qt.cpp
#g++ -O2 -Wall -o qt_o2m.x qt_o2m.cpp moc_bench_qt.cpp -lstdc++ -I$QTDIR/include -L$QTDIR/lib -lqt-mt
#g++ -O2 -Wall -o qt_m2o.x qt_m2o.cpp moc_bench_qt.cpp -lstdc++ -I$QTDIR/include -L$QTDIR/lib -lqt-mt
#g++ -O2 -Wall -o qt_rand.x qt_rand.cpp moc_bench_qt.cpp -lstdc++ -I$QTDIR/include -L$QTDIR/lib -lqt-mt

echo "Compiling boost bench..."
#g++ -O2 -Wall -o boost_o2m.x boost_o2m.cpp -lstdc++  -lboost_signals
#g++ -O2 -Wall -o boost_m2o.x boost_m2o.cpp -lstdc++  -lboost_signals
#g++ -O2 -Wall -o boost_rand.x boost_rand.cpp -lstdc++ -lboost_signals

echo "Compiling slotsig non-unique bench..."
#g++ -O2 -Wall -o slotsig_nonunique_m2o.x ../slotsig/slotsig_bases.cpp slotsig_nonunique_m2o.cpp -lstdc++
#g++ -O2 -Wall -o slotsig_nonunique_o2m.x ../slotsig/slotsig_bases.cpp slotsig_nonunique_o2m.cpp -lstdc++
#g++ -O2 -Wall -o slotsig_nonunique_rand.x ../slotsig/slotsig_bases.cpp slotsig_nonunique_rand.cpp -lstdc++

echo "Compiling libsigc++ bench..."
#g++ -O2 -Wall -o libsig_o2m.x libsig_o2m.cpp -I$HOME/opt/include/sigc++-2.0 -I/home/yves/opt/lib/sigc++-2.0/include/ -L$HOME/opt/lib -lstdc++ -lsigc-2.0
#g++ -O2 -Wall -o libsig_m2o.x libsig_m2o.cpp -I$HOME/opt/include/sigc++-2.0 -I/home/yves/opt/lib/sigc++-2.0/include/ -L$HOME/opt/lib -lstdc++ -lsigc-2.0
#g++ -O2 -Wall -o libsig_rand.x libsig_rand.cpp -I$HOME/opt/include/sigc++-2.0 -I/home/yves/opt/lib/sigc++-2.0/include/ -L$HOME/opt/lib -lstdc++ -lsigc-2.0

s="_"
for prg in slotsig qt boost slotsig_nonunique libsig; do
  for what in m2o o2m rand; do
    echo "Running $prg, $what"
    echo "# nb, conn/sec, mem allocated, calls/sec, disconn/sec, mem freed" > $prg$s$what.txt
    i="100"
    while [ $i -lt 7001 ];
    do
      ./$prg$s$what.x $i  >> $prg$s$what.txt
      i=$((i+100))
    done
  done
done

