
// g++ -O2 -Wall -o boost_m2o.x boost_m2o.cpp -lstdc++  -lboost_signals

#include <boost/signals/signal0.hpp>

#include "common.h"

typedef boost::signal0<void> Sig0Type ;

struct Slot
{
  void operator() ()
  { }
} ;

typedef std::vector<Sig0Type*> Sig0Array ;
typedef std::vector<Slot*> SlotArray ;
typedef std::vector<boost::signals::connection> ConnArray ;

int main(int argc, char* argv[])
{
  unsigned nb = 100 ;
  if ( argc > 1 )
    nb = atol(argv[1]) ;
  if ( nb == 0 )
    nb = 100 ;

  Sig0Array signals(nb, 0) ;
  ConnArray conn(nb) ;
  unsigned i ;
  for (i = 0 ; i < nb ; ++i)
    signals[i] = new Sig0Type ;

  Slot slot ;

  std::cout << " " << std::setw(10) << nb ;
  unsigned long current_data_size = data_size() ;

  init_chrono() ;
  boost::signals::connection c ;
  for (i = 0 ; i < nb ; ++i)
    conn[i] = signals[i]->connect(slot) ;
  print_speed(nb) ;
  std::cout << std::setw(10) << data_size()-current_data_size ;

  init_chrono() ;
  for (i = 0 ; i < nb ; ++i)
    (*(signals[i]))() ;
  double e = elapsed() ;
  if ( e < 1.0 )
  {
    unsigned nb_rep = (unsigned)(1.0/e) ;
    init_chrono() ;
    for (unsigned rep = 0 ; rep < nb_rep ; ++rep)
      for (i = 0 ; i < nb ; ++i)
        (*(signals[i]))() ;
    print_speed(nb_rep*nb) ;
  }
  else
    print_speed(e, nb) ;

  current_data_size = data_size() ;
  init_chrono() ;
  for (i = 0 ; i < nb ; ++i)
    conn[i].disconnect() ;
  print_speed(nb) ;
  std::cout << std::setw(10) << current_data_size-data_size() << "\n" ;

  return 0 ;
}
