
#include <iostream>
#include <iomanip>
#include <vector>
#include <sys/time.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>
#include <string>
#include <fstream>

struct timeval t_start ;
struct timeval t_stop ;

void init_chrono()
{
  gettimeofday(&t_start, 0) ;
}

double elapsed()
{
  gettimeofday(&t_stop, 0) ;
  return (double)((t_stop.tv_sec - t_start.tv_sec)) +
             ((double)(t_stop.tv_usec - t_start.tv_usec))/1000000.0 ;
}

void print_speed(double e, unsigned long nb)
{
  std::cout << " " << std::fixed << std::setprecision(2) << std::setw(15) << nb/e ;
}

void print_speed(unsigned long nb)
{
  double e = elapsed() ;
  print_speed(e, nb) ;
}

unsigned long data_size()
{
  pid_t pid = getpid() ;
  char spid[1000] = {'\0',} ;
  sprintf(spid, "%d", pid) ;
  std::string s("/proc/") ;
  s += spid ;
  s += "/status" ;
  std::ifstream f(s.c_str()) ;
  std::string w ;
  while ( ! f.eof() )
  {
    f >> w ;
    if ( w.find("VmData") == 0 )
    {
      f >> w ;
      return atol(w.c_str()) ;
    }
  }
  return 0 ;
}
