
// moc bench_qt.h > moc_bench_qt.cpp
// g++ -O2 -Wall -o qt_rand.x qt_rand.cpp moc_bench_qt.cpp -lstdc++ -I$QTDIR/include -L$QTDIR/lib -lqt-mt

#include "common.h"
#include "bench_qt.h"

int main(int argc, char* argv[])
{
  unsigned nb = 100 ;
  if ( argc > 1 )
    nb = atol(argv[1]) ;
  if ( nb == 0 )
    nb = 100 ;
    
  Sig0Array _signals(nb, 0) ;
  SlotArray _slots(nb, 0) ;
  unsigned i ;
  for (i = 0 ; i < nb ; ++i)
  {
    _signals[i] = new Sig0Type ;
    _slots[i] = new Slot ;
  }
  
  std::cout << " " << std::setw(10) << nb ;
  unsigned long current_data_size = data_size() ;

  srandom(1) ;
  unsigned nb_actions = 0 ;
 
  init_chrono() ;
  while ( elapsed() < 2 )
  {
    _signals[random()%nb]->connect(_slots[random()%nb], SLOT(slot())) ;
    ++nb_actions ;
  }
  print_speed(nb_actions) ;
  std::cout << std::setw(10) << data_size()-current_data_size ;

  init_chrono() ;
  for (i = 0 ; i < nb ; ++i)
    _signals[i]->activate() ;
  double e = elapsed() ;
  if ( e < 1.0 )
  {
    unsigned nb_rep = (unsigned)(1.0/e) ;
    init_chrono() ;
    for (unsigned rep = 0 ; rep < nb_rep ; ++rep)
      for (i = 0 ; i < nb ; ++i)
        _signals[i]->activate() ;
    print_speed(nb_rep*nb) ;
  }
  else
    print_speed(e, nb) ;

  current_data_size = data_size() ;
  init_chrono() ;
  nb_actions = 0 ;
  while ( elapsed() < 2 )
  {
    _signals[random()%nb]->disconnect(_slots[random()%nb], SLOT(slot())) ;
    ++nb_actions ;
  }
  print_speed(nb_actions) ;
  std::cout << std::setw(10) << current_data_size-data_size() << "\n" ;

  return 0 ;
}
