#include <iostream>
#include <slotsig/slotsig_1.h>

int slot_1(double d)
{ 
  std::cout << "::slot_1(" << d << ") -> " << (int)d << "\n" ;
  return (int)d ;
}

int slot_2(double d)
{
  std::cout << "::slot_2(" << d << ") -> " << (int)(2*d) << "\n" ;
  return (int)(2*d) ;
}

int sum = 0 ;
void accum(int a)
{ sum += a ; }

bool pred(int a)
{ return ((a%3) != 0) ; }

int main (int argc, char* argv[])
{
  SlotSig::Sig1<int, double> sig_1 ;
  SlotSig::Sig1<int, double> sig_2 ;
  
  sig_1.connect(slot_1) ;
  sig_2.connect(slot_2) ;
  
  sig_1.connect(&sig_2) ;
  
  std::cout << "Running sig_1...\n" ;
  sig_1.run(3.14) ;
  std::cout << "Running sig_1 with accumulator...\n" ;
  sig_1.run(accum, 3.14) ;
  std::cout << "Sum = " << sum << "\n" ;
  std::cout << "Running sig_1 with predicate...\n" ;
  sig_1.run_if(pred, 3.14) ;
  
  return 0 ;
}
