#!/usr/bin/python

import sys, string

def generate_header(nb) :
  Tpl = {"@@"            : "", \
         "@NB@"          : "0", \
         "@TPL_PARAMS@"  : "", \
         "@TPL_ARGS@"    : "", \
         "@FCT_PARAMS@"  : "", \
         "@FCT_ARGS@"    : "", \
         "@SLT_PARAMS@"  : "" \
         }

  Tpl["@NB@"] = "%d"%nb
  if ( nb > 0 ) :
    Tpl["@@"] = ","
    r = range(nb)
    Tpl["@TPL_PARAMS@"] = string.join(["typename _ARG%d_TYPE_" % i for i in r], ", ")
    Tpl["@TPL_ARGS@"]   = string.join(["_ARG%d_TYPE_" % i for i in r], ", ")
    Tpl["@FCT_PARAMS@"] = string.join(["_ARG%d_TYPE_ arg%d" % (i,i) for i in r], ", ")
    Tpl["@FCT_ARGS@"]   = string.join(["arg%d" % i for i in r], ", ")
    Tpl["@SLT_PARAMS@"] = string.join(["typename Type2Param<_ARG%d_TYPE_>::ParamType arg%d" % (i,i) for i in r], ", ")
  print "Generating SlotSig header for %d parameters into <slotsig/slotsig_%d.h>..." % (nb,nb)
  f_in = file("slotsig_template.h", 'r')
  slotsig = f_in.readlines()
  slotsig = string.join(slotsig, '')
  f_in.close()
  f_out = file("slotsig/slotsig_%d.h"%nb, 'w')
  for tr in Tpl.items() :
    slotsig = string.replace(slotsig, tr[0], tr[1])
  f_out.write(slotsig)
  f_out.close()

def generate_test(nb) :
  Test = {"@@" : "", \
          "@NB@" : "0", \
          "@FCT_PARAMS@" : "", \
          "@FCT_CONCAT@" : "\"\"", \
          "@TPL_ARGS@" : ""
          }

  Test["@NB@"] = "%d"%nb
  if ( nb > 0 ) :
    Test["@@"] = ","
    r = range(nb)
    Test["@FCT_PARAMS@"] = string.join(["const std::string& s%d" % i for i in r], ", ")
    Test["@FCT_CONCAT@"] = string.join(["s%d" % i for i in r], " + \", \" + ")
    Test["@TPL_ARGS@"] = string.join(["const std::string&" for i in r], ", ")
  print "Generating test file for <slotsig_%d.h> into tests/test_%d.cpp..." % (nb,nb)
  f_in = file("test_template.cpp", 'r')
  lines = f_in.readlines()
  f_in.close()
  num_emit = 0
  test = ""
  for l in lines :
    pos = string.find(l, "##")
    if ( pos >= 0 ) :
      if ( not (l[pos+2] == '@') ) :
        num_emit += 1
        l = string.replace(l, "##", "#%d"%num_emit)
      else :
        l = string.replace(l, "##", "%d"%num_emit)
    test += l
  if ( nb > 0 ) :
    for id in range(1,num_emit+1) :
      Test["@FCT_ARGS_%d@"%id] = string.join(["\"e%d_%d\""%(id,i) for i in r], ", ")
  else :
    for id in range(1,num_emit+1) :
      Test["@FCT_ARGS_%d@"%id] = ""
  for tr in Test.items() :
    test = string.replace(test, tr[0], tr[1])
  f_out = file("tests/test_%d.cpp"%nb, 'w')
  f_out.write(test)
  f_out.close()

if ( __name__ == "__main__" ) :
  nb = 16
  if ( len(sys.argv) == 2 ) :
    nb = int(sys.argv[1])
  for i in range(nb+1) :
    generate_header(i)
    generate_test(i)
