
// Compile command :
// g++ -Wall -o test_12.x -I.. -lstdc++ ../slotsig/slotsig_bases.cpp test_12.cpp
#include <iostream>
#include <string>
#include <slotsig/slotsig_12.h>

class C1 : public SlotSig::SlotsSetBase
{
  public:
    C1() : SlotSig::SlotsSetBase() { }

    std::string m1(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11)
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C1::m1 (" << s << ")\n" ;
      return "C1::m1" ;
    }

    std::string m2(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11) const
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C1::m2 (" << s << ")\n" ;
      return "C1::m2" ;
    }

    virtual std::string vm1(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11)
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C1::vm1 (" << s << ")\n" ;
      return "C1::vm1" ;
    }

    virtual std::string vm2(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11) const
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C1::vm2 (" << s << ")\n" ;
      return "C1::vm2" ;
    }
} ; // C1

class C2 : public C1
{
  public:
    C2() : C1() { }

    virtual std::string vm1(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11)
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C2::vm1 (" << s << ")\n" ;
      return "C2::vm1" ;
    }

    virtual std::string vm2(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11) const
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C2::vm2 (" << s << ")\n" ;
      return "C2::vm2" ;
    }
} ; // C2

class C3
{
  public:
    C3() { }
    virtual std::string m(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11)
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C3::m (" << s << ")\n" ;
      return "C3::m" ;
    }
} ; // C3

std::string global_slot(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11)
{
  std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
  std::cout << "::global_slot (" << s << ")\n" ;
  return "::global_slot" ;
}

struct Accum
{
  Accum() : str("") { }

  void operator() (const std::string& s)
  { str += (s + " ") ; }

  std::string str ;
} ; // Accum

struct Pred
{
  Pred() : cpt(0) { }

  bool operator() (const std::string&)
  { return ( ((++cpt) % 3) != 0 ) ; }

  unsigned cpt ;
} ; // Pred

int main()
{
  std::cout << "--- Test program START ---\n" ;

  std::cout << "---\n"
    << "--- Basic tests\n"
    << "---\n\n" ;
  C1* c1 = new C1 ;
  C2* c2 = new C2 ;
  typedef SlotSig::Sig12<std::string, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&> SigType ;
  SigType* sig1 = new SigType(false) ;
  SigType* sig2 = new SigType ;
  Accum accum ;
  Pred pred ;

  std::cout << "--- Connecting all methods from c1 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (global_slot)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::vm2)) << "\n" ;
  std::cout << "--- Emitting sig1 #1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e1_0", "e1_1", "e1_2", "e1_3", "e1_4", "e1_5", "e1_6", "e1_7", "e1_8", "e1_9", "e1_10", "e1_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #2 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e2_0", "e2_1", "e2_2", "e2_3", "e2_4", "e2_5", "e2_6", "e2_7", "e2_8", "e2_9", "e2_10", "e2_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #3 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e3_0", "e3_1", "e3_2", "e3_3", "e3_4", "e3_5", "e3_6", "e3_7", "e3_8", "e3_9", "e3_10", "e3_11")) << "\n" ;

  std::cout << "--- Re-connecting all methods from c1 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (global_slot)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::vm2)) << "\n" ;
  std::cout << "--- Emitting sig1 #4...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e4_0", "e4_1", "e4_2", "e4_3", "e4_4", "e4_5", "e4_6", "e4_7", "e4_8", "e4_9", "e4_10", "e4_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #5 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e5_0", "e5_1", "e5_2", "e5_3", "e5_4", "e5_5", "e5_6", "e5_7", "e5_8", "e5_9", "e5_10", "e5_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #6 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e6_0", "e6_1", "e6_2", "e6_3", "e6_4", "e6_5", "e6_6", "e6_7", "e6_8", "e6_9", "e6_10", "e6_11")) << "\n" ;

  std::cout << "--- Ensuring uniqueness of slots in sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->set_ensure_unique(true)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->enforce_unique()) << "\n" ;
  std::cout << "--- Emitting sig1 #7...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e7_0", "e7_1", "e7_2", "e7_3", "e7_4", "e7_5", "e7_6", "e7_7", "e7_8", "e7_9", "e7_10", "e7_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #8 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e8_0", "e8_1", "e8_2", "e8_3", "e8_4", "e8_5", "e8_6", "e8_7", "e8_8", "e8_9", "e8_10", "e8_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #9 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e9_0", "e9_1", "e9_2", "e9_3", "e9_4", "e9_5", "e9_6", "e9_7", "e9_8", "e9_9", "e9_10", "e9_11")) << "\n" ;

  std::cout << "--- Connecting all methods from c2 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::vm2)) << "\n" ;
  std::cout << "--- Emitting sig1 #10...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e10_0", "e10_1", "e10_2", "e10_3", "e10_4", "e10_5", "e10_6", "e10_7", "e10_8", "e10_9", "e10_10", "e10_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #11 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e11_0", "e11_1", "e11_2", "e11_3", "e11_4", "e11_5", "e11_6", "e11_7", "e11_8", "e11_9", "e11_10", "e11_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #12 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e12_0", "e12_1", "e12_2", "e12_3", "e12_4", "e12_5", "e12_6", "e12_7", "e12_8", "e12_9", "e12_10", "e12_11")) << "\n" ;

  std::cout << "--- Re-connecting all methods from c2 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::vm2)) << "\n" ;
  std::cout << "--- Emitting sig1 #13...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e13_0", "e13_1", "e13_2", "e13_3", "e13_4", "e13_5", "e13_6", "e13_7", "e13_8", "e13_9", "e13_10", "e13_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #14 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e14_0", "e14_1", "e14_2", "e14_3", "e14_4", "e14_5", "e14_6", "e14_7", "e14_8", "e14_9", "e14_10", "e14_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #15 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e15_0", "e15_1", "e15_2", "e15_3", "e15_4", "e15_5", "e15_6", "e15_7", "e15_8", "e15_9", "e15_10", "e15_11")) << "\n" ;

  std::cout << "--- Connecting all methods from c1 and c2 to sig2...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (global_slot)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::vm2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c2, &C2::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c2, &C2::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c2, &C2::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c2, &C2::vm2)) << "\n" ;
  std::cout << "--- Emitting sig2 #16...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e16_0", "e16_1", "e16_2", "e16_3", "e16_4", "e16_5", "e16_6", "e16_7", "e16_8", "e16_9", "e16_10", "e16_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #17 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig2->run(accum, "e17_0", "e17_1", "e17_2", "e17_3", "e17_4", "e17_5", "e17_6", "e17_7", "e17_8", "e17_9", "e17_10", "e17_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #18 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run_if(pred, "e18_0", "e18_1", "e18_2", "e18_3", "e18_4", "e18_5", "e18_6", "e18_7", "e18_8", "e18_9", "e18_10", "e18_11")) << "\n" ;

  std::cout << "--- Disconnecting global_slot, c1->m1, c1->vm2, c2->m2 and c2->vm1 from sig2...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->disconnect(global_slot)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->disconnect(c1, &C1::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->disconnect(c1, &C1::vm2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->disconnect(c2, &C2::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->disconnect(c2, &C2::vm1)) << "\n" ;
  std::cout << "--- Emitting sig1 #19...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e19_0", "e19_1", "e19_2", "e19_3", "e19_4", "e19_5", "e19_6", "e19_7", "e19_8", "e19_9", "e19_10", "e19_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #20 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e20_0", "e20_1", "e20_2", "e20_3", "e20_4", "e20_5", "e20_6", "e20_7", "e20_8", "e20_9", "e20_10", "e20_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #21 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e21_0", "e21_1", "e21_2", "e21_3", "e21_4", "e21_5", "e21_6", "e21_7", "e21_8", "e21_9", "e21_10", "e21_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #22...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e22_0", "e22_1", "e22_2", "e22_3", "e22_4", "e22_5", "e22_6", "e22_7", "e22_8", "e22_9", "e22_10", "e22_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #23 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig2->run(accum, "e23_0", "e23_1", "e23_2", "e23_3", "e23_4", "e23_5", "e23_6", "e23_7", "e23_8", "e23_9", "e23_10", "e23_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #24 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run_if(pred, "e24_0", "e24_1", "e24_2", "e24_3", "e24_4", "e24_5", "e24_6", "e24_7", "e24_8", "e24_9", "e24_10", "e24_11")) << "\n" ;

  std::cout << "--- Deleting c1...\n" ;
  delete c1 ;
  c1 = 0 ;
  std::cout << "--- Emitting sig1 #25...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e25_0", "e25_1", "e25_2", "e25_3", "e25_4", "e25_5", "e25_6", "e25_7", "e25_8", "e25_9", "e25_10", "e25_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #26 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e26_0", "e26_1", "e26_2", "e26_3", "e26_4", "e26_5", "e26_6", "e26_7", "e26_8", "e26_9", "e26_10", "e26_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #27 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e27_0", "e27_1", "e27_2", "e27_3", "e27_4", "e27_5", "e27_6", "e27_7", "e27_8", "e27_9", "e27_10", "e27_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #28...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e28_0", "e28_1", "e28_2", "e28_3", "e28_4", "e28_5", "e28_6", "e28_7", "e28_8", "e28_9", "e28_10", "e28_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #29 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig2->run(accum, "e29_0", "e29_1", "e29_2", "e29_3", "e29_4", "e29_5", "e29_6", "e29_7", "e29_8", "e29_9", "e29_10", "e29_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #30 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run_if(pred, "e30_0", "e30_1", "e30_2", "e30_3", "e30_4", "e30_5", "e30_6", "e30_7", "e30_8", "e30_9", "e30_10", "e30_11")) << "\n" ;

  std::cout << "--- Deleting sig1...\n" ;
  delete sig1 ;
  sig1 = 0 ;
  std::cout << "--- Emitting sig2 #31...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e31_0", "e31_1", "e31_2", "e31_3", "e31_4", "e31_5", "e31_6", "e31_7", "e31_8", "e31_9", "e31_10", "e31_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #32 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig2->run(accum, "e32_0", "e32_1", "e32_2", "e32_3", "e32_4", "e32_5", "e32_6", "e32_7", "e32_8", "e32_9", "e32_10", "e32_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #33 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run_if(pred, "e33_0", "e33_1", "e33_2", "e33_3", "e33_4", "e33_5", "e33_6", "e33_7", "e33_8", "e33_9", "e33_10", "e33_11")) << "\n" ;

  std::cout << "--- Deleting c2...\n" ;
  delete c2 ;
  std::cout << "--- Emitting sig2 #34...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e34_0", "e34_1", "e34_2", "e34_3", "e34_4", "e34_5", "e34_6", "e34_7", "e34_8", "e34_9", "e34_10", "e34_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #35 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig2->run(accum, "e35_0", "e35_1", "e35_2", "e35_3", "e35_4", "e35_5", "e35_6", "e35_7", "e35_8", "e35_9", "e35_10", "e35_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #36 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run_if(pred, "e36_0", "e36_1", "e36_2", "e36_3", "e36_4", "e36_5", "e36_6", "e36_7", "e36_8", "e36_9", "e36_10", "e36_11")) << "\n" ;

  std::cout << "--- Deleting sig2...\n" ;
  delete sig2 ;
  
  std::cout << "\n---\n"
    << "--- Chaining tests\n"
    << "---\n\n" ;
    
  c1 = new C1() ;
  sig1 = new SigType() ;
  sig2 = new SigType() ;
  
  std::cout << "--- Connecting global_slot, C1::m1 and C1::vm2 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (global_slot)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::vm2)) << "\n" ;
  std::cout << "--- Emitting sig1 #37...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e37_0", "e37_1", "e37_2", "e37_3", "e37_4", "e37_5", "e37_6", "e37_7", "e37_8", "e37_9", "e37_10", "e37_11")) << "\n" ;
  
  std::cout << "--- Connecting C1::m2 and C1::vm1 to sig2...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::vm1)) << "\n" ;
  std::cout << "--- Emitting sig2 #38...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e38_0", "e38_1", "e38_2", "e38_3", "e38_4", "e38_5", "e38_6", "e38_7", "e38_8", "e38_9", "e38_10", "e38_11")) << "\n" ;
 
  std::cout << "--- Connecting sig2 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect(sig2)) << "\n" ;
  std::cout << "--- Emitting sig1 #39...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e39_0", "e39_1", "e39_2", "e39_3", "e39_4", "e39_5", "e39_6", "e39_7", "e39_8", "e39_9", "e39_10", "e39_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #40 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e40_0", "e40_1", "e40_2", "e40_3", "e40_4", "e40_5", "e40_6", "e40_7", "e40_8", "e40_9", "e40_10", "e40_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #41 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e41_0", "e41_1", "e41_2", "e41_3", "e41_4", "e41_5", "e41_6", "e41_7", "e41_8", "e41_9", "e41_10", "e41_11")) << "\n" ;

  std::cout << "--- Deleting sig2...\n" ;
  delete sig2 ;
  std::cout << "--- Emitting sig1 #42...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e42_0", "e42_1", "e42_2", "e42_3", "e42_4", "e42_5", "e42_6", "e42_7", "e42_8", "e42_9", "e42_10", "e42_11")) << "\n" ;

  std::cout << "--- Recreating sig2 and reconnecting C1::m2 and C1::vm1 to sig2...\n" ;
  sig2 = new SigType() ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::vm1)) << "\n" ;
  std::cout << "--- Reconnecting sig2 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect(sig2)) << "\n" ;
  std::cout << "--- Emitting sig1 #43...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e43_0", "e43_1", "e43_2", "e43_3", "e43_4", "e43_5", "e43_6", "e43_7", "e43_8", "e43_9", "e43_10", "e43_11")) << "\n" ;
  std::cout << "--- Connecting sig1 to sig2 (creating cycle)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect(sig1)) << "\n" ;
  std::cout << "--- Emitting sig1 #44...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e44_0", "e44_1", "e44_2", "e44_3", "e44_4", "e44_5", "e44_6", "e44_7", "e44_8", "e44_9", "e44_10", "e44_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #45...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e45_0", "e45_1", "e45_2", "e45_3", "e45_4", "e45_5", "e45_6", "e45_7", "e45_8", "e45_9", "e45_10", "e45_11")) << "\n" ;
  
  std::cout << "--- Deleting sig1...\n" ;
  delete sig1 ;
  std::cout << "--- Emitting sig2 #46...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e46_0", "e46_1", "e46_2", "e46_3", "e46_4", "e46_5", "e46_6", "e46_7", "e46_8", "e46_9", "e46_10", "e46_11")) << "\n" ;
  
  std::cout << "--- Deleting c1...\n" ;
  delete c1 ;
  std::cout << "--- Deleting sig2...\n" ;
  delete sig2 ;
  
  std::cout << "\n---\n"
    << "--- Cloning tests\n"
    << "---\n\n" ;
  
  c1 = new C1 ;
  sig1 = new SigType() ;
  
  std::cout << "--- Connecting global_slot, C1::m1 and C1::vm2 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (global_slot)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::vm2)) << "\n" ;
  std::cout << "--- Emitting sig1 #47...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e47_0", "e47_1", "e47_2", "e47_3", "e47_4", "e47_5", "e47_6", "e47_7", "e47_8", "e47_9", "e47_10", "e47_11")) << "\n" ;
  
  std::cout << "--- Cloning sig1 into sig2...\n" ;
  sig2 = sig1->clone() ;
  std::cout << "--- Emitting sig2 #48...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e48_0", "e48_1", "e48_2", "e48_3", "e48_4", "e48_5", "e48_6", "e48_7", "e48_8", "e48_9", "e48_10", "e48_11")) << "\n" ;
  
  std::cout << "--- Deleting sig1...\n" ;
  delete sig1 ;
  std::cout << "--- Emitting sig2 #49...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e49_0", "e49_1", "e49_2", "e49_3", "e49_4", "e49_5", "e49_6", "e49_7", "e49_8", "e49_9", "e49_10", "e49_11")) << "\n" ;

  std::cout << "--- Creating sig1 as clone of sig2...\n" ;
  sig1 = new SigType(*sig2) ;  
  std::cout << "--- Emitting sig1 #50...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e50_0", "e50_1", "e50_2", "e50_3", "e50_4", "e50_5", "e50_6", "e50_7", "e50_8", "e50_9", "e50_10", "e50_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #51...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e51_0", "e51_1", "e51_2", "e51_3", "e51_4", "e51_5", "e51_6", "e51_7", "e51_8", "e51_9", "e51_10", "e51_11")) << "\n" ;

  std::cout << "--- Deleting sig2...\n" ;
  delete sig2 ;
  std::cout << "--- Emitting sig1 #52...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e52_0", "e52_1", "e52_2", "e52_3", "e52_4", "e52_5", "e52_6", "e52_7", "e52_8", "e52_9", "e52_10", "e52_11")) << "\n" ;
  
  std::cout << "--- Creating sig2, connecting C1::m2...\n" ;
  sig2 = new SigType ;
  std::cout << "   " << SlotSig::error2str(sig2->connect(c1, &C1::m2)) << "\n" ;
  std::cout << "--- Emitting sig1 #53...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e53_0", "e53_1", "e53_2", "e53_3", "e53_4", "e53_5", "e53_6", "e53_7", "e53_8", "e53_9", "e53_10", "e53_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #54...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e54_0", "e54_1", "e54_2", "e54_3", "e54_4", "e54_5", "e54_6", "e54_7", "e54_8", "e54_9", "e54_10", "e54_11")) << "\n" ;
  
  std::cout << "--- Copying sig1 into sig2...\n" ;
  *sig2 = *sig1 ;
  std::cout << "--- Emitting sig1 #55...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e55_0", "e55_1", "e55_2", "e55_3", "e55_4", "e55_5", "e55_6", "e55_7", "e55_8", "e55_9", "e55_10", "e55_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #56...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e56_0", "e56_1", "e56_2", "e56_3", "e56_4", "e56_5", "e56_6", "e56_7", "e56_8", "e56_9", "e56_10", "e56_11")) << "\n" ;
  
  std::cout << "--- Creating sig3, connecting C1::m2...\n" ;
  SigType* sig3 = new SigType() ;
  std::cout << "   " << SlotSig::error2str(sig3->connect(c1, &C1::m2)) << "\n" ;
  std::cout << "--- Emitting sig3 #57...\n" ;
  std::cout << "  " << SlotSig::error2str(sig3->run("e57_0", "e57_1", "e57_2", "e57_3", "e57_4", "e57_5", "e57_6", "e57_7", "e57_8", "e57_9", "e57_10", "e57_11")) << "\n" ;
  std::cout << "--- Connecting sig3 to sig1...\n" ;
  std::cout << "   " << SlotSig::error2str(sig1->connect(sig3)) << "\n" ;
  std::cout << "--- Copying sig1 into sig2...\n" ;
  *sig2 = *sig1 ;
  std::cout << "--- Emitting sig1 #58...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e58_0", "e58_1", "e58_2", "e58_3", "e58_4", "e58_5", "e58_6", "e58_7", "e58_8", "e58_9", "e58_10", "e58_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #59...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e59_0", "e59_1", "e59_2", "e59_3", "e59_4", "e59_5", "e59_6", "e59_7", "e59_8", "e59_9", "e59_10", "e59_11")) << "\n" ;
  
  std::cout << "--- Deleting sig3...\n" ;
  delete sig3 ;
  std::cout << "--- Emitting sig1 #60...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e60_0", "e60_1", "e60_2", "e60_3", "e60_4", "e60_5", "e60_6", "e60_7", "e60_8", "e60_9", "e60_10", "e60_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #61...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e61_0", "e61_1", "e61_2", "e61_3", "e61_4", "e61_5", "e61_6", "e61_7", "e61_8", "e61_9", "e61_10", "e61_11")) << "\n" ;

  std::cout << "--- Deleting c1...\n" ;
  delete c1 ;
  c1 = 0 ;
  std::cout << "--- Emitting sig1 #62...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e62_0", "e62_1", "e62_2", "e62_3", "e62_4", "e62_5", "e62_6", "e62_7", "e62_8", "e62_9", "e62_10", "e62_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #63...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e63_0", "e63_1", "e63_2", "e63_3", "e63_4", "e63_5", "e63_6", "e63_7", "e63_8", "e63_9", "e63_10", "e63_11")) << "\n" ;

  std::cout << "--- Deleting sig1...\n" ;
  delete sig1 ;
  std::cout << "--- Emitting sig2 #64...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e64_0", "e64_1", "e64_2", "e64_3", "e64_4", "e64_5", "e64_6", "e64_7", "e64_8", "e64_9", "e64_10", "e64_11")) << "\n" ;
  
  std::cout << "--- Deleting sig2...\n" ;
  delete sig2 ;
  
  std::cout << "\n---\n"
    << "--- \"Free\" connection tests\n"
    << "---\n\n" ;
    
  C3* c3 = new C3() ;
  sig1 = new SigType() ;
  
  std::cout << "--- Connecting C3::m to sig1...\n" ;
  std::cout << "   " << SlotSig::error2str(sig1->connect(c3, &C3::m)) << "\n" ;
  std::cout << "--- Emitting sig1 #65...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e65_0", "e65_1", "e65_2", "e65_3", "e65_4", "e65_5", "e65_6", "e65_7", "e65_8", "e65_9", "e65_10", "e65_11")) << "\n" ;

  std::cout << "--- Disconnecting C3::m to sig1...\n" ;
  std::cout << "   " << SlotSig::error2str(sig1->disconnect(c3, &C3::m)) << "\n" ;
  std::cout << "--- Emitting sig1 #66...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e66_0", "e66_1", "e66_2", "e66_3", "e66_4", "e66_5", "e66_6", "e66_7", "e66_8", "e66_9", "e66_10", "e66_11")) << "\n" ;
  
  std::cout << "--- Re-connecting C3::m to sig1...\n" ;
  std::cout << "   " << SlotSig::error2str(sig1->connect(c3, &C3::m)) << "\n" ;
  std::cout << "--- Emitting sig1 #67...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e67_0", "e67_1", "e67_2", "e67_3", "e67_4", "e67_5", "e67_6", "e67_7", "e67_8", "e67_9", "e67_10", "e67_11")) << "\n" ;
  
  std::cout << "--- Announcing c3 deletion...\n" ;
  SlotSig::about_to_delete(c3) ;
  std::cout << "--- Emitting sig1 #68...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e68_0", "e68_1", "e68_2", "e68_3", "e68_4", "e68_5", "e68_6", "e68_7", "e68_8", "e68_9", "e68_10", "e68_11")) << "\n" ;
  
  std::cout << "--- Deleting sig1...\n" ;
  delete sig1 ;
  
  std::cout << "\n--- Test program END ----\n" ;
  return 0 ;
}
